-- Somewhat revamped friend system.
rawset(_G, "cv_combifriend", {})
local MAXPLAYERS = #players
for i = 0, MAXPLAYERS-1 do
	cv_combifriend[i] = CV_RegisterVar({"storage__hcombi_friend_" .. i, "0", CV_NETVAR, {
		MIN = 0,
		MAX = MAXPLAYERS,
	}})
end

rawset(_G, "hcombi_playercount", function()
	local headcount = 0
	for p in players.iterate
		if (p and p.valid) then
			headcount = $+1
		end
	end
	return headcount
end)

addHook("PlayerThink", function(player)
	player.hcombifrenpending = $ or 0
	player.hcombihasfren = $ or 0
	player.hcombifrennum = $ or 0
	player.hcombifren = $ or "none"
end)

-- prevent Oops! All Gargoyles!
addHook("PlayerQuit", function(player)
	if player.hcombifrenpending and players[player.hcombifrenpending-1].valid then
		players[player.hcombifrenpending-1].hcombifrenpending = 0
		players[player.hcombifrenpending-1].hcombihasfren = 0
		players[player.hcombifrenpending-1].hcombifrennum = 0
		players[player.hcombifrenpending-1].hcombifren = "none"
		chatprintf(players[player.hcombifrenpending-1], "\x84" .. player.name .. " has left and is longer your combi friend. :(", true)
	end
	
	player.hcombifrenpending = 0
	player.hcombihasfren = 0
	player.hcombifrennum = 0
	player.hcombifren = "none"
end)

local function PRINTF(p,m) CONS_Printf(p,m) end -- discard the third argument
COM_AddCommand("combi_friend", function(player, friend, in_chat)
	local printfunc = in_chat and chatprintf or PRINTF
	local color = in_chat and "\x84" or ""
	local frne = tonumber(friend)
	
	if not hcombi.cv_combi.value then
		if not in_chat then
			printfunc(player, color.."Combi isn't on right now, but you can still friend someone!", false)
		end
	end
	
	if not hcombi.cv_combifriends.value then
		printfunc(player, color.."The server has disabled combi friends. :(", false)
		
		return
	end
	
	if not (player and player.valid)
		printfunc(player, color.."You're not in-game yet!")
		return
	end

	if friend:lower() == "none" then
		if player.hcombifrenpending and players[player.hcombifrenpending-1].valid then
			players[player.hcombifrenpending-1].hcombifrenpending = 0
			players[player.hcombifrenpending-1].hcombihasfren = 0
			players[player.hcombifrenpending-1].hcombifrennum = 0
			players[player.hcombifrenpending-1].hcombifren = "none"
			chatprintf(players[player.hcombifrenpending-1], "\x84" .. player.name .. " is no longer your combi friend. :(", true)
		end
		
		player.hcombifrenpending = 0
		player.hcombihasfren = 0
		player.hcombifrennum = 0
		player.hcombifren = "none"
		printfunc(player, color.."You no longer have a combi friend. :(", false)
		
		return
	end
	
	if player.hcombifrenpending
		if friend:lower() == players[player.hcombifrenpending-1].name:lower()
			printfunc(player, color.."They're already your combi friend!")
			return
		elseif (frne ~= #players[player.hcombifrenpending-1] or friend:lower() ~= players[player.hcombifrenpending-1].name:lower() or friend:lower() ~= player.hcombifren:lower())
			printfunc(player, color.."You can't befriend a new player when you already have one. Say \"friend none\" to unfriend first.")
			return
		end
	else
		if (friend:lower() ~= player.hcombifren:lower() and player.hcombifren:lower() ~= "none") then
			printfunc(player, color.."You can't befriend a new player when you already have one. Say \"friend none\" to unfriend first.")
			return
		end
	end
	
	local target = nil
	local results = {}
	
	if frne ~= nil and frne >= 0
		if players[frne] == player
			printfunc(player, color.."You can't befriend yourself!")
			return
		else
			target = players[frne]
		end
	end
	
	if target == nil
		for q in players.iterate
			if string.find(q.name:lower(), friend:lower(),0,true)~=nil then
					table.insert(results, q)
			end
		end
		if #results > 1 then
			printfunc(player, color.."Found more than one player matching that name. Be more specific or use a node:")
			for i=1,#results do
				printfunc(player, results[i].name.." [Node "..#results[i].."]")
			end
			return
		elseif #results < 1 then
			printfunc(player, color.."No players found by that name. (In-game players only)")
			return
		else
			if results[1] == player
				printfunc(player, color.."You can't befriend yourself!")
				return
			else
				target = results[1]
			end
		end
	end
	
	local friend_player = nil
	if target and target.valid then
		friend_player = target
	end

	if not friend_player then
		if not in_chat then
			CONS_Printf(player, "combi_friend \"<name>\": Pick someone to always be your combi partner! They must return the favor.")
		end
		
		return
	end
	
	player.hcombifrenpending = #friend_player+1
	
	local str = friend_player.name .. " will be your friend if they accept."
	if friend_player.hcombifrenpending and friend_player.hcombifrenpending-1 == #player then
		str = friend_player.name .. " will always be your combi partner."
		players[player.hcombifrenpending-1].hcombihasfren = true
	elseif friend_player.hcombifrenpending and friend_player.hcombifrenpending-1 ~= #player then
		str = friend_player.name.." already has a friend!"
		player.hcombifrenpending = 0
		printfunc(player, color.. str, false)
		return
	end
	
	printfunc(player, color .. str, false)

	str = player.name .. " wants to be combi friends. Say \"friend " .. player.name .. "\" to accept."
	if friend_player.hcombifrenpending and friend_player.hcombifrenpending-1 == #player then
		str = player.name .. " accepted your friend request, and will always be your combi partner."
		player.hcombihasfren = true
	elseif friend_player.hcombifrenpending and friend_player.hcombifrenpending-1 ~= #player then
		str = player.name.. " already has a friend!"
	end

	chatprintf(friend_player, "\x84" .. str, true)
end)

addHook("PlayerMsg", function(player, msgtype, target, message)
	if message:sub(1, 7) == "friend " then
		COM_BufInsertText(player, "combi_friend \"" .. message:sub(8) .. "\" in_chat")
		return true
	end
	return
end)