freeslot("sfx_lft1", "sfx_rgt1", "sfx_sgt2", "sfx_wng2")

-- i still dont know why this isnt just a lua global
local starttime = 6 * TICRATE + (3 * TICRATE / 4)

-- Returns -1 if turning left and 1 if turning right.
local function HandleTurnKeys(cmd)
	local pn = 0
	local target = 0
	if cmd.driftturn == 0 then return 0 end
	target = ((abs(cmd.driftturn) - 1)/125)+1;
	if (target > 4) then
		target = 4;
	end
	if (cmd.driftturn < 0) then
		target = -target;
	end

	if (pn != target) then
		if (abs(pn - target) == 1) then
			pn = target;
		elseif (pn < target) then
			pn = $ + 2
		else //if (pn > target)
			pn = $ - 2
		end
	end

	target = -pn
	if target > 1 then target = 1 end
	if target < -1 then target = -1 end
	return target
end

-- Returns either:
-- 0: Nothing
-- 1: Turn Left
-- 2: Turn Right
-- 3: Straight
-- 4: Wrong Turn/Way
local function HandleTurnButtons(player)
	-- Cooldown.
	if player.turnsignalcooldown > 0 then return 0 end
	local keystate = 0
	-- turn signals
	if (player.cmd.buttons & BT_CUSTOM1) then 
		keystate = 1
	end
	if (player.cmd.buttons & BT_CUSTOM2) then 
		keystate = 2
	end
	if (player.cmd.buttons & BT_CUSTOM3) then 
		keystate = 3
	end
	if (player.cmd.buttons & BT_CUSTOM3) and (player.cmd.buttons & BT_BACKWARD) then 
		keystate = 4
	end
	return keystate
end

local function PartnerSound(mo, id) 
	if not mo.player or not mo.player.has_partner then return end
	S_StartSound(mo, id, mo.player) 
end 

local function PlayTurnSound(player)
	local soundfunc = PartnerSound
	local ppartmo = hcombi.ReturnPartner(player, player.has_partner)
	local partner_name = "the wind"
	local partner_player = ppartmo.player
	if partner_player and partner_player.valid then
		partner_name = partner_player.name
	end
	if player.turnsignalcooldown > 0 then return end
	if player.turnsignaltype == 1 then -- turn left
		soundfunc(ppartmo, sfx_lft1)
		soundfunc(player.mo, sfx_lft1)
		--print(player.name.." told "..partner_name.." to turn left")
	end
	if player.turnsignaltype == 2 then -- turn right
		soundfunc(ppartmo, sfx_rgt1)
		soundfunc(player.mo, sfx_rgt1)
		--print(player.name.." told "..partner_name.." to turn right")
	end
	if player.turnsignaltype == 3 then -- straight
		soundfunc(ppartmo, sfx_sgt2)
		soundfunc(player.mo, sfx_sgt2)
		--print(player.name.." told "..partner_name.." to go straight")
	end
	if player.turnsignaltype == 4 then -- wrong
		soundfunc(ppartmo, sfx_wng2)
		soundfunc(player.mo, sfx_wng2)
		--print(player.name.." told "..partner_name.." that they suck")
	end
	if partner_player and partner_player.valid then
		partner_player.receivedturnsignal = player.turnsignaltype
	end
	player.turnsignalsent = player.turnsignaltype
	player.turnsignaltype = 0
end

addHook("ThinkFrame", function()
	-- do not execute ANYTHING here when combi is not on.
	if not hcombi.combi_on then return end
	
	for player in players.iterate do
		if leveltime < starttime then
			player.turnsignalcooldown = 0
			player.turnsignaltype = 0
			player.turnsignalsent = 0
		end
		
		if player.spectator then continue end
		if leveltime < starttime then continue end
		-- HOW DO YOU STILL NOT HAVE A PARTNER????
		if not player.fake_combi or not player.old_combi then continue end
		if player.turnsignalcooldown > 0 then 
			player.turnsignalcooldown = $ - 1 
		end
		local ppartmo = hcombi.ReturnPartner(player, player.has_partner)
		if ppartmo.player and ppartmo.player.valid then
			ppartmo.player.receivedcooldown = ppartmo.player.receivedcooldown or 0
			ppartmo.player.receivedturnsignal = ppartmo.player.receivedturnsignal or 0
			if ppartmo.player.receivedcooldown > 0 then 
				ppartmo.player.receivedcooldown = $ - 1 
			end
		end
		player.turnsignaltype = HandleTurnButtons(player)
		if player.turnsignaltype == 0 then continue end
		-- wait a second before you can call again
		PlayTurnSound(player)
		player.turnsignalcooldown = 1*TICRATE
		if ppartmo.player and ppartmo.player.valid then
			ppartmo.player.receivedcooldown = player.turnsignalcooldown
		end
		-- player.lastangleturn = player.cmd.angleturn
	end
end)